package client;

import java.io.IOException;
import java.net.SocketException;
import java.util.Enumeration;
import java.util.Hashtable;

import net.ConnectionInfo;
import net.TimeoutLimitException;
import server.LoginException;
import server.UnnavailableLoginException;
import server.User;

public class FachadaClient {
	Client client;
	public FachadaClient(Client client){
		this.client=client;
	}
	public void cadastrar(User usuario) throws IOException, TimeoutLimitException, UnnavailableLoginException, ServerException{
		client.cadastrar(usuario);
	}
	public void logar(String login, String senha) throws TimeoutLimitException, LoginException{
		client.logar(login, senha);
	}
	public void addListener(ClientGuiListener listener){
		client.addGuiListener(listener);
	}
	public void logout() throws TimeoutLimitException{
		client.logout();
	}
	public void addFriend(String login) throws LoginException, ServerException, TimeoutLimitException, IOException, UnnavailableLoginException{
		client.adicionarAmigo(login);
	}
	public void sendMsg(String msg, ConnectionInfo ci, ClientGuiListener listener) throws TimeoutLimitException{
		client.sendMsg(msg, ci, listener);
	}
	public void convidar(ConnectionInfo ci, Hashtable<ConnectionInfo, String> tabelaDeParticipantes, ClientGuiListener listener, ClientGuiListener groupListener) throws IOException, TimeoutLimitException{
		client.convidaParaGroup(ci, tabelaDeParticipantes, listener, groupListener);
	}
	public void sendGroupMsg(String msg, Hashtable<ConnectionInfo, String> tabelaDeParticipantes, ClientGuiListener groupListener) throws GroupException{
		client.sendGroup(msg, tabelaDeParticipantes, groupListener);
	}
	public void realizarChamada(ConnectionInfo ci, ClientGuiListener listener) throws TimeoutLimitException, SocketException{
		client.chamadaDeVoz(ci, listener);
	}
	public void connectToGroup(Enumeration<ConnectionInfo> ips, ClientGuiListener listener, ClientGuiListener groupListener) throws TimeoutLimitException{
		client.connectToGroup(ips, listener, groupListener);
	}
}
